varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform sampler2D u_normalMap;
uniform float shadertime;

vec3 waveNormal(vec2 p)
{
    vec3 normal = texture2D(u_normalMap, p).xyz;
    normal = normal * 2.0 - 1.0;
    return normalize(normal);
}

void main() 
{
	vec4 pointC = vec4(0.0);
    pointC = texture2D(CC_Texture0, vec2(v_texCoord.x, v_texCoord.y));
    if(pointC.a>0.1)
    {
    float timeFactor = 0.001;
    float offsetFactor = 0.1;
    float refractionFactor = 0.3;
    vec2 tempTexCoord=vec2(v_texCoord.x/2.0,v_texCoord.y/2.0);
    float wavePos=shadertime * timeFactor;
    vec3 normal = waveNormal(tempTexCoord + vec2(0,wavePos));
    vec2 p = 2.0 * v_texCoord - 1.0;
    vec3 eyePos = vec3(0.0, 0.0, 100.0);
    vec3 inVec = normalize(vec3(p, 0.0) - eyePos);
    vec3 refractVec = refract(inVec, normal, refractionFactor);
    vec2 texCoordFinal=vec2(v_texCoord.x+refractVec.x*offsetFactor,v_texCoord.y+refractVec.y*offsetFactor);
    gl_FragColor = texture2D(CC_Texture0, texCoordFinal) * v_fragmentColor;
    gl_FragColor.xyz=mix(gl_FragColor.xyz,vec3(1.0,0.27,0.0),0.2);
    //gl_FragColor.xyz=vec3(0.7,1.0,0);
    //gl_FragColor.xyz=cross(gl_FragColor.xyz,vec3(1.0,0.0,1.0));
    }
    else
    {
    gl_FragColor =pointC;
    }
		
}