varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform sampler2D u_normalMap;
uniform float shadertime;
uniform float mapx;
uniform float mapy;
vec3 waveNormal(vec2 p)
{
	vec2 tempVec =vec2(p.x,p.y);
	tempVec.x=mod(p.x,1.0);
	tempVec.y=mod(p.y,1.0);
    vec3 normal = texture2D(u_normalMap, tempVec).xyz;
    normal = normal * 2.0 - 1.0;
    return normalize(normal);
}

void main() 
{
	float mapNewX = mod((v_texCoord.x+mapx),1.0);
	float mapNewY = mod((v_texCoord.y+mapy),1.0);
    vec2 moveTexCoord=vec2(mapNewX,mapNewY);
    float timeFactor = 0.001;
    float offsetFactor = 0.1;
    float refractionFactor = 0.8;
    vec2 tempTexCoord=vec2(moveTexCoord.x/3.0,moveTexCoord.y/3.0);
    float wavePos=shadertime;
    vec3 normal = waveNormal(tempTexCoord + vec2(wavePos,0));
    vec2 p = 2.0 * moveTexCoord - 1.0;
    vec3 eyePos = vec3(100.0, 0, 100.0);
    vec3 inVec = normalize(vec3(p, 0.0) - eyePos);
    vec3 refractVec = refract(inVec, normal, refractionFactor);
    vec2 texCoordFinal=vec2(moveTexCoord.x+refractVec.x*offsetFactor,moveTexCoord.y+refractVec.y*offsetFactor);
    gl_FragColor = texture2D(CC_Texture0, texCoordFinal)* v_fragmentColor;
}