#ifdef GL_ES
precision mediump float;
#endif
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform float lightStrength;
uniform float timer;
void main()
{
    vec4 src_color = texture2D(CC_Texture0, v_texCoord).rgba;
    float width = 0.15;       //流光的宽度范围 (调整该值改变流光的宽度)
	//float time = CC_Time.y - floor(CC_Time.y+1.0);
    float start = timer;  //流光的起始x坐标
    float strength = 0.01*lightStrength;   //流光增亮强度   (调整该值改变流光的增亮强度)
    float offset = 0.25;      //偏移值         (调整该值改变流光的倾斜程度)
    //if( start <= v_texCoord.x && v_texCoord.x <= (start + width))
    if( v_texCoord.x < (start - offset * v_texCoord.y) &&  v_texCoord.x > (start - offset * v_texCoord.y - width))
    {
		float right = start - offset * v_texCoord.y;
		float mid = right-width*0.5;
		float curDis = abs(mid - v_texCoord.x);
		float del = (width-curDis)/width;
        vec3 improve = strength * vec3(255.0*del, 255.5*del, 255.5*del);
        vec3 result = improve * vec3( src_color.r, src_color.g, src_color.b);
        gl_FragColor = vec4(result, src_color.a)*v_fragmentColor;
    }
	else
	{
		vec4 noColor = vec4(0,0,0,0);
        gl_FragColor = noColor*v_fragmentColor;
    }
}